#lang racket

;;;; 2. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 28.2.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - iteratívna rekurzia,
;;;; - funkcionálne programovanie,
;;;; - Cantorova párovacia funkcia a aritmetizácia karteziánskeho súčinu.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 2
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 1
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 6.3.2018 (utorok) do 14:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define (identity x) x)
(define (square x) (* x x))
(define (succ x) (+ x 1))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Funkcionálne programovanie.

;;; Sekcia. Programy ako argumenty.

;; Príklad. Nasledujúci komponent obsahuje program pre funkcionál, ktorý má
;; túto vlastnosť: 
;;   sum(f,m,n) = f(m) + f(m+1) + ··· + f(n)

(define (sum f m n)
  (if (> m n) 0 (+ (sum f m (- n 1)) (f n))))

;; (sum identity 1 10)
;; (query (λ (n) (sum identity 1 n)) 0 10)

;; Alternatívna implementácia spätnou rekurziou.

(define (sum2 f m n)
  (if (> m n) 0 (+ (f m) (sum2 f (+ m 1) n))))

;; (sum2 identity 1 10)
;; (query (λ (n) (sum2 identity 1 n)) 0 10)

;; Úloha. Implementujte predchadzajúci program ako iteratívny process.

(define (fast-sum f m n) ...)

;; (fast-sum identity 1 10)
;; (query (λ (n) (fast-sum identity 1 n)) 0 10)

;; Úloha. Zostrojte program pre funkcionál, ktorý má túto vlastnosť: 
;;   product(f,m,n) = f(m) × f(m+1) × ··· × f(n)

(define (product f m n) ...)

;; (product identity 1 6)
;; (query (λ (n) (product identity 1 n)) 1 6)

;; (1 bod)
;; Úloha. Implementujte predchadzajúci program ako iteratívny process.

(define (fast-product f m n) ...)

;; (fast-product identity 1 6)
;; (query (λ (n) (fast-product identity 1 n)) 1 6)

;; Úloha. Zostrojte iteratívny program pre funkcionál, ktorý má túto vlastnosť: 
;;   iter(f,n,x) = f f ... f(x)
;; Funkcia f sa tu n-krát aplikuje na vstup x.

(define (iter f n x) ...)

;; (iter succ 10 1)
;; (query (λ (n) (iter succ n 9)) 0 10)

;; (1 bod)
;; Úloha. Vyriešte cvičenie 1.32 v [1]. Program implementujte ako iteratívny process.

(define (accumulate combiner null-value term a next b) ...)

;; (accumulate + 0 identity 1 succ 10)
;; (accumulate * 1 identity 1 succ 6)

;; (prémia 1 bod)
;; Úloha. Zostrojte iteratívny program pre funkcionál root, ktorý má túto
;; vlastnosť:
;;   f(0) = 0 ∧ ∀x∃y x < f(y) → f root(f,x) ≤ x < f(root(f,x)+1)
;; Návod. Implementujte funkcionál tak, aby platilo:
;;   f(0) = 0 ∧ ∀x∃y x < f(y) → root(f,x) = min{y | x < f(y+1)}

(define (root f x) ...)

;; (query (λ (x) (root square x)) 0 20)
