#lang racket

;;;; 2. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 28.2.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - iteratívna rekurzia,
;;;; - funkcionálne programovanie,
;;;; - Cantorova párovacia funkcia a aritmetizácia karteziánskeho súčinu.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 0
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 2
;;;; Odovzdať do 6.3.2018 (utorok) do 14:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define (fib n)
  (cond [(= n 0) 0]
        [(= n 1) 1]
        [else (+ (fib (- n 1)) (fib (- n 2)))]))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Aritmetizácia dátových štruktúr.

;;; Sekcia. Cantorova párovacia funkcia.

;; Trojuholníkové čísla.
;;   T(n) = 1 + 2 + 3 + ··· + n
 
(define (T n) (quotient (* n (+ n 1)) 2))

;; (query T 0 10)

;; Úloha. Definujte pravú inverznú funkciu k trojuholníkovej funkcii:
;;   T⁻¹(n) = m ↔ T(m) ≤ n ∧ n < T(m+1)
;; Návod. Využite, že platí
;;   8T(n)+1 = (2n+1)²

(define (T⁻¹ n) ...)

;; (query T⁻¹ 0 10)

;; Úloha. Definujte Cantorovu párovacia funkciu.

(define (J x y) ...)

;; Úloha. Definujte prvú a druhú projekciu párovacej funkcie:
;;   K J(x,y) = x ∧ L J(x,y) = y

(define (K x) ...)
(define (L x) ...)

;; (projekt 2 body)
;; Úloha. Definujte funkciu twofibs takú, že
;;   twofibs(n) = J(fib(n),fib(n+1))
;; Implementujte ju pomocou párovacej funkcie a jej projekcií bez použitia fib.

(define (twofibs n) ...)

;; (query (λ (n) (list (fib n) (K (twofibs n)))) 0 10)
